; WARNING! YOU WILL NEED TO MODIFY WLA-DX WITH MAX_NAME_LENGTH SET TO 256 IN defines.h!

.MEMORYMAP
defaultslot 0
slotsize $8000
slot 0 $0000
slotsize $2000
slot 1 $C000
.endme

.rombankmap
bankstotal 1
banksize $8000
banks 1
.endro

.bank 0 slot 0
.org $0000
	di
	im 1
	jp start
.org $0008
	jp rnd_get
.org $0038
	push af
	in a,($bf)
	ld ($cc07),a
	rst $08
	pop af
	reti

.org $0066
	retn

rnd_get:
	push hl
	ccf
	ld hl,$CC00
	rr (hl)
	inc hl
	rr (hl)
	jp nc, +
		push af
		ld a,(hl)
		xor %00000001
		ld (hl),a
		dec hl
		ld a,(hl)
		xor %01000000
		ld (hl),a
		pop af
+:	pop hl
	ret

start:
	ld sp,$dff0
	; load VDP registers
	ld hl,vdpregs
	ld e,$80
	-:
		; TODO: make sure there's a 29+ cycle wait
		ld a,(hl)
		out ($bf),a
		inc hl
		ld a,e
		out ($bf),a
		inc e
		ld a,e
		cp $80+11
		jr nz,-
	
	; now load the palette
	; XXX: do we get the nice 8-cycle speed now or are we still stuck on 29-cycle?
	ld c,$be
	ld e,$00
	ld hl,vdppal
	-:
		ld a,e
		out ($bf),a
		inc e
		ld a,$c0
		out ($bf),a
		ld a,(hl)
		out ($be),a
		inc hl
		ld a,e
		cp 32
		jr nz,-
	
	; load some tiles
	ld a,$00
	out ($bf),a
	ld a,$40
	out ($bf),a
	
	ld b,$00
	ld c,$08
	ld hl,font
	-:
		ld a,(hl)
		out ($be),a
		out ($be),a
		out ($be),a
		out ($be),a
		inc hl
		djnz -
		dec c
		jr nz,-
	
	; load some tiles, pt 2: patch up some screwup
	ld a,$00
	out ($bf),a
	ld a,$60
	out ($bf),a
	
	ld b,$00
	ld c,$04
	ld hl,font
	-:
		ld a,(hl)
		out ($be),a
		out ($be),a
		out ($be),a
		xor a
		out ($be),a
		inc hl
		djnz -
		dec c
		jr nz,-
	
	; set sprite 0 to y = $D0
	ld a,$00
	out ($bf),a
	ld a,$7f
	out ($bf),a
	ld a,$d0
	out ($be),a
	
	; clear screen
	call cls
	
	; build msg table @ $C002
	ld bc,$0000
	ld de,$C002
	ld hl,rfk_msgs
	--:
		ex de,hl
		ld (hl),e
		inc hl
		ld (hl),d
		inc hl
		ex de,hl
		-:
			inc hl
			ld a,(hl)
			and a
			jr nz,-
		inc hl
		inc bc
		ld a,(hl)
		and a
		jr nz,--
	
	ld hl,$C000
	ld (hl),c
	inc hl
	ld (hl),b
	
	; do something interesting?
	ld de,64*0+0+$7800
	ld hl,str_intro
	call puts
	inc hl
	ld de,64*2+0+$7800
	call puts
	inc hl
	ld de,64*4+0+$7800
	call puts
	inc hl
	ld de,64*7+0+$7800
	call puts
	inc hl
	ld de,64*20+0+$7800
	call puts
	
	; show screen
	ld a,%11000000
	out ($bf),a
	ld a,$81
	out ($bf),a
	
	; get random number, wait for button press
	-:
		rst $08
		in a,($dc)
		and $30
		xor $30
		jr z,-
	
	; hide screen
	; TODO: 29-cycle timing
	ld a,%10000000
	out ($bf),a
	ld a,$81
	out ($bf),a
	
	; clear screen
	call cls
	
	; print text up top
	ld de,64*0+0+$7800
	ld hl,str_rfk
	call puts
	
	; draw bar
	ld a,$c0
	out ($bf),a
	ld a,$78
	out ($bf),a
	ld b,$20
	ld c,$be
	ld de,$0000 + '-'
	-:
		out (c),e
		out (c),d
		djnz -
	
	; generate items, we'll pick 24
	; a Z80 should be powerful enough to handle going through a list of 24 items each frame
	ld b,24
	ld hl,$D000
	; set player first, then 24 items, first item being kitten
	ld (hl),10+4
	inc hl
	ld (hl),16
	inc hl
	ld (hl),'#'
	inc hl
	ld (hl),$00
	inc hl
	ld (hl),$00
	inc hl
	
	---:
		push hl
		pop ix
		; set Y
		ld a,$00
		rst $08
		rla
		rst $08
		rla
		rst $08
		rla
		rst $08
		rla
		rst $08
		rla
		cp 20
		jr nc,---
		add a,$04
		ld (hl),a
		inc hl
		
		; set X
		ld a,$00
		rst $08
		rla
		rst $08
		rla
		rst $08
		rla
		rst $08
		rla
		rst $08
		rla
		ld (hl),a
		dec hl
		
		; check if it's in the list already
		ld iy,$D000
		-:
			ld a,(iy+0)
			xor (ix+0)
			ld c,a
			ld a,(iy+1)
			xor (ix+1)
			or c
			jr z,---
			inc iy
			inc iy
			inc iy
			inc iy
			inc iy
			; end of list?
			ld a,iyl
			cp ixl
			jr nz,-
			ld a,iyh
			cp ixh
			jr nz,-
		
		inc hl
		inc hl
		
		; set char
		--:
			ld a,$00
			rst $08
			rla
			rst $08
			rla
			rst $08
			rla
			rst $08
			rla
			rst $08
			rla
			rst $08
			rla
			rst $08
			rla
			cp 94 ; check if in range
			jr nc,--
			add a,$21
			ld (hl),a
		
		; check if it's in the list already
		ld iy,$D000
		-:
			ld a,(iy+2)
			cp (ix+2)
			jr z,--
			inc iy
			inc iy
			inc iy
			inc iy
			inc iy
			; end of list?
			ld a,iyl
			cp ixl
			jr nz,-
			ld a,iyh
			cp ixh
			jr nz,-
		
		inc hl
		
		; pick a random message
		--:
		ld de,$0000
		rst $08
		rl e
		rl d
		rst $08
		rl e
		rl d
		rst $08
		rl e
		rl d
		rst $08
		rl e
		rl d
		rst $08
		rl e
		rl d
		rst $08
		rl e
		rl d
		rst $08
		rl e
		rl d
		rst $08
		rl e
		rl d
		rst $08
		rl e
		rl d
		; check if in range
		ld a,d
		and a
		jr z, +
		ld a,($C000)
		ld c,a
		ld a,e
		cp c
		jr nc,--
		+:
		
		; get pointer
		sla e
		rl d
		ld a,e
		add a,$02
		ld e,a
		ld a,d
		adc a,$C0
		ld d,a
		
		; fetch!
		ex de,hl
		ld a,(hl)
		inc hl
		ld h,(hl)
		ld l,a
		ex de,hl
		
		; now STICK IT IN.
		ld (hl),e
		inc hl
		ld (hl),d
		dec hl
		
		; check if it's in the list already
		ld iy,$D000
		-:
			ld a,(iy+3)
			xor (ix+3)
			ld c,a
			ld a,(iy+4)
			xor (ix+4)
			or c
			jp z,--
			inc iy
			inc iy
			inc iy
			inc iy
			inc iy
			; end of list?
			ld a,iyl
			cp ixl
			jp nz,-
			ld a,iyh
			cp ixh
			jp nz,-
		
		inc hl
		inc hl
		
		; plot on screen
		ld d,$00
		ld e,(ix+0)
		
		rl e
		rl d
		rl e
		rl d
		rl e
		rl d
		rl e
		rl d
		rl e
		rl d
		
		ld a,e
		add a,(ix+1)
		ld e,a
		ld a,d
		adc a,$3C
		ld d,a
		sla e
		rl d
		
		ld a,e
		out ($bf),a
		ld a,d
		out ($bf),a
		ld a,(ix+2)
		out ($be),a
		xor a
		out ($be),a
		dec b
		jp nz,--- ; huge distance apparently
	
	; store end of list marker
	ld a,l
	ld ($cc08),a
	ld a,h
	ld ($cc09),a
	
	; set kitten ptr to special value
	ld iy,$d005
	ld (iy+3),$00
	ld (iy+4),$FF
	
	; set player sprite
	call setps
	
	; enable interrupts for randomness
	ei
	; show screen + enable frame interrupt
	ld a,%11100000
	out ($bf),a
	ld a,$81
	out ($bf),a
	in a,($bf)
	
	; blank key queue & last keys pressed
	ld a,%00000000
	ld ($cc04),a
	ld a,%00000000
	ld ($cc05),a
	
	; main game loop
	main_loop:
		; find which directions we CAN take
		; clear pointer list
		ld hl,$cc10
		xor a
		ld (hl),a
		ld de,$cc11
		ld bc,4*2-1
		ldir
		
		; give appropriate x and y
		ld ix,$d000
		ld d,(ix+1) ; x
		ld e,(ix+0) ; y
		
		; fill in the info
		ld iy,$cc10
		dec e
		call filldir
		inc iy
		inc iy
		inc e
		inc e
		call filldir
		inc iy
		inc iy
		dec e
		dec d
		call filldir
		inc iy
		inc iy
		inc d
		inc d
		call filldir
		
		; wait until we have a vblank
		-:
			ei
			halt
			ld hl,$cc07
			bit 7,(hl)
			jr z,-
		
		res 7,(hl) ; clear flag
		
		; find which directions we WANT to take
		ld a,($cc05)
		ld b,a
		in a,($dc)
		ld ($cc05),a
		cpl
		and $0f
		and b
		ld c,a
		ld a,($cc04)
		or c
		ld ($cc04),a ; key queue
		
		; check queue
		ld hl,$cc04
		bit 0,(hl)
		jp nz,key_up
		bit 1,(hl)
		jp nz,key_down
		bit 2,(hl)
		jp nz,key_left
		bit 3,(hl)
		jp nz,key_right
		jp main_loop
		
		key_up:
			res 0,(hl)
			ld a,(ix+0)
			cp 4
			jp z, main_loop
			ld hl,($cc10)
			call ckmsg
			jp nz,main_loop
			dec (ix+0)
			call setps
			jp main_loop
		key_down:
			res 1,(hl)
			ld a,(ix+0)
			cp 23
			jp z, main_loop
			ld hl,($cc12)
			call ckmsg
			jp nz,main_loop
			inc (ix+0)
			call setps
			jp main_loop
		key_left:
			res 2,(hl)
			ld a,(ix+1)
			cp 0
			jp z, main_loop
			ld hl,($cc14)
			call ckmsg
			jp nz,main_loop
			dec (ix+1)
			call setps
			jp main_loop
		key_right:
			res 3,(hl)
			ld a,(ix+1)
			cp 31
			jp z, main_loop
			ld hl,($cc16)
			call ckmsg
			jp nz,main_loop
			inc (ix+1)
			call setps
			jp main_loop

ckmsg:
	ld a,h
	cp $00 ; empty?
	ret z
	cp $FF ; kitten?
	jp z,foundkitten
	
	; clear text area
	ld a,$40
	out ($bf),a
	ld a,$78
	out ($bf),a
	ld b,128
	xor a
	-:
		out ($be),a
		djnz -
	
	; draw bar
	ld a,$c0
	out ($bf),a
	ld a,$78
	out ($bf),a
	ld b,$20
	ld c,$be
	ld de,$0000 + '-'
	-:
		out (c),e
		out (c),d
		djnz -
	
	; draw text
	ld de,64*1+0+$7800
	call puts
	
	
	
	; set z flag
	ld a,h
	and a
	ret

foundkitten:
	; hide screen
	; TODO? 29+ cycle timing
	ld a,%00000000
	out ($bf),a
	ld a,$81
	out ($bf),a
	
	; put heart on screen
	ld hl,str_heart
	ld de,$7800
	call puts
	
	; set sprite 0 to y = $D0
	ld a,$00
	out ($bf),a
	ld a,$7f
	out ($bf),a
	ld a,$d0
	out ($be),a
	
	; show screen
	ld a,%11000000
	out ($bf),a
	ld a,$81
	out ($bf),a
	
	; get random number, wait for button press
	-:
		rst $08
		in a,($dc)
		and $30
		xor $30
		jr z,-
	
	; restart!
	jp $0000

filldir:
	ld hl,$d005
	-:
		ld a,(hl) ; y
		inc hl
		xor e
		ld c,a
		ld a,(hl) ; x
		inc hl
		inc hl ; skip char
		xor d
		or c
		jr z,+ ; x and y match?
		
		inc hl
		inc hl
		
		ld a,($cc08)
		xor l
		ld c,a
		ld a,($cc09)
		xor h
		or c
		jr nz,-
	
	ret
	
	+:
	; fill the pointer
	ld a,(hl)
	ld (iy+0),a
	inc hl
	ld a,(hl)
	ld (iy+1),a
	
	ret

setps:
	ld ix,$D000
	ld a,$00
	out ($bf),a
	ld a,$7F
	out ($bf),a
	ld a,(ix+0)
	sla a
	sla a
	sla a
	dec a
	out ($be),a
	ld a,$80
	out ($bf),a
	ld a,$7F
	out ($bf),a
	ld a,(ix+1)
	sla a
	sla a
	sla a
	out ($be),a
	ld a,(ix+2)
	out ($be),a
	ret

cls:
	ld a,$00
	out ($bf),a
	ld a,$78
	out ($bf),a
	ld bc,$0007
	ld a,$20
	-:
		out ($be),a
		djnz -
		dec c
		jr nz,-
	ret
	
puts:
	ld c,$bf
	out (c),e
	out (c),d
	dec c
	-:
		ld a,(hl)
		and a
		ret z
		out (c),a
		inc hl
		xor a
		out (c),a
		jp -

vdpregs:
	.db %00000100
	.db %00000000
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %11111111
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11111111

vdppal:
	.db %00000001
	.db %00000010
	.db %00001000
	.db %00001010
	.db %00100000
	.db %00100010
	.db %00100100
	.db %00101010
	.db %00010101
	.db %00010111
	.db %00011101
	.db %00011111
	.db %00110101
	.db %00110111
	.db %00111101
	.db %00111111
	.db %00000000
	.db %00000010
	.db %00001000
	.db %00001010
	.db %00100000
	.db %00100010
	.db %00100100
	.db %00101010
	.db %00010101
	.db %00010111
	.db %00011101
	.db %00011111
	.db %00110101
	.db %00110111
	.db %00111101
	.db %00101111

font:
	.incbin "rawcga.bin"

str_rfk: .db "robotfindskitten", 0

str_heart:
	;    00000000001111111111222222222233
	;    01234567890123456789012345678901
	.db "                                " ; 00
	.db "                                " ; 01
	.db "                                " ; 02
	.db "                                " ; 03
	.db "           ###    ###           " ; 04
	.db "         ######  ######         " ; 05
	.db "        ################        " ; 06
	.db "        ################        " ; 07
	.db "         ##############         " ; 08
	.db "          ############          " ; 09
	.db "           ##########           " ; 10
	.db "            ########            " ; 11
	.db "             ######             " ; 12
	.db "              ####              " ; 13
	.db "               ##               " ; 14
	.db "                                " ; 15
	.db "                                " ; 16
	.db "                                " ; 17
	.db "                                " ; 18
	.db "        You found kitten!       " ; 19
	.db "  Press any button to restart.  " ; 20
	.db "                                " ; 21
	.db "                                " ; 22
	.db "                                " ; 23
	.db 0

str_intro:
	.db "   By the illustrious Leonard   "
	.db "    Richardson (C) 1997, 2000   ", 0
	.db "Written originally for the Nerth"
	.db "Pork robotfindskitten contest", 0
	.db "   Sega Master System port by   "
	.db "Ben ",34,"GreaseMonkey",34," Russell, 2010", 0
	.db "In this game, you are robot (#)."
	.db "Your job is to find kitten. This"
	.db "   task is complicated by the   "
	.db "   existence of various things  "
	.db "which are not kitten. Robot must"
	.db "touch items to determine if they"
	.db "are kitten or not. The game ends"
	.db "     when robotfindskitten.     "
	.db " Alternatively, you may end the "
	.db "    game by hitting the RESET   "
	.db "  button. See the documentation "
	.db "      for more information.", 0
	.db "   Press any button to start.", 0

rfk_msgs:
.db "",34,"I pity the fool who mistakes me for kitten!",34,", sez Mr. T.", 0
.db "That's just an old tin can.", 0
.db "It's an altar to the horse god.", 0
.db "A box of dancing mechanical pencils. They dance! They sing!", 0
.db "It's an old Duke Ellington record.", 0
.db "A box of fumigation pellets.", 0
.db "A digital clock. It's stuck at 2:17 PM.", 0
.db "That's just a charred human corpse.", 0
.db "I don't know what that is, but it's not kitten.", 0
.db "An empty shopping bag. Paper or plastic?", 0
.db "Could it be... a big ugly bowling trophy?", 0
.db "A coat hanger hovers in thin air. Odd.", 0
.db "Not kitten, just a packet of Kool-Aid(tm).", 0
.db "A freshly-baked pumpkin pie.", 0
.db "A lone, forgotten comma, sits here, sobbing.", 0
.db "ONE HUNDRED THOUSAND CARPET FIBERS!!!!!", 0
.db "It's Richard Nixon's nose!", 0
.db "It's Lucy Ricardo. ",34,"Aaaah, Ricky!",34,", she says.", 0
.db "You stumble upon Bill Gates' stand-up act.", 0
.db "Just an autographed copy of the Kama Sutra.", 0
.db "It's the Will Rogers Highway. Who was Will Rogers, anyway?", 0
.db "It's another robot, more advanced in design than you but strangely immobile.", 0
.db "Leonard Richardson is here, asking people to lick him.", 0
.db "It's a stupid mask, fashioned after a beagle.", 0
.db "Your State Farm Insurance(tm) representative!", 0
.db "It's the local draft board.", 0
.db "Seven 1/4",34," screws and a piece of plastic.", 0
.db "An 80286 machine.", 0
.db "One of those stupid ",34,"Homes of the Stars",34," maps.", 0
.db "A signpost saying ",34,"TO KITTEN",34,". It points in no particular direction.", 0
.db "A hammock stretched between a tree and a volleyball pole.", 0
.db "A Texas Instruments of Destruction calculator.", 0
.db "It's a dark, amphorous blob of matter.", 0
.db "Just a pincushion.", 0
.db "It's a mighty zombie talking about some love and prosperity.", 0
.db "",34,"Dear robot, you may have already won our 10 MILLION DOLLAR prize...",34,"", 0
.db "It's just an object.", 0
.db "A mere collection of pixels.", 0
.db "A badly dented high-hat cymbal lies on its side here.", 0
.db "A marijuana brownie.", 0
.db "A plush Chewbacca.", 0
.db "Daily hunger conditioner from Australasia", 0
.db "Just some stuff.", 0
.db "Why are you touching this when you should be finding kitten?", 0
.db "A glorious fan of peacock feathers.", 0
.db "It's some compromising photos of Babar the Elephant.", 0
.db "A copy of the Weekly World News. Watch out for the chambered nautilus!", 0
.db "It's the proverbial wet blanket.", 0
.db "A ",34,"Get Out of Jail Free",34," card.", 0
.db "An incredibly expensive ",34,"Mad About You",34," collector plate.", 0
.db "Paul Moyer's necktie.", 0
.db "A haircut and a real job. Now you know where to get one!", 0
.db "An automated robot-hater. It frowns disapprovingly at you.", 0
.db "An automated robot-liker. It smiles at you.", 0
.db "It's a black hole. Don't fall in!", 0
.db "Just a big brick wall.", 0
.db "You found kitten! No, just kidding.", 0
.db "Heart of Darkness brand pistachio nuts.", 0
.db "A smoking branding iron shaped like a 24-pin connector.", 0
.db "It's a Java applet.", 0
.db "An abandoned used-car lot.", 0
.db "A shameless plug for Crummy: http://www.crummy.com/", 0
.db "A shameless plug for the UCLA Linux Users Group: http://linux.ucla.edu/", 0
.db "A can of Spam Lite.", 0
.db "This is another fine mess you've gotten us into, Stanley.", 0
.db "It's scenery for ",34,"Waiting for Godot",34,".", 0
.db "This grain elevator towers high above you.", 0
.db "A Mentos wrapper.", 0
.db "It's the constellation Pisces.", 0
.db "It's a fly on the wall. Hi, fly!", 0
.db "This kind of looks like kitten, but it's not.", 0
.db "It's a banana! Oh, joy!", 0
.db "A helicopter has crashed here.", 0
.db "Carlos Tarango stands here, doing his best impression of Pat Smear.", 0
.db "A patch of mushrooms grows here.", 0
.db "A patch of grape jelly grows here.", 0
.db "A spindle, and a grindle, and a bucka-wacka-woom!", 0
.db "A geyser sprays water high into the air.", 0
.db "A toenail? What good is a toenail?", 0
.db "You've found the fish! Not that it does you much good in this game.", 0
.db "A Buttertonsils bar.", 0
.db "One of the few remaining discoes.", 0
.db "Ah, the uniform of a Revolutionary-era minuteman.", 0
.db "A punch bowl, filled with punch and lemon slices.", 0
.db "It's nothing but a G-thang, baby.", 0
.db "IT'S ALIVE! AH HA HA HA HA!", 0
.db "This was no boating accident!", 0
.db "Wait! This isn't the poker chip! You've been tricked! DAMN YOU, MENDEZ!", 0
.db "A livery stable! Get your livery!", 0
.db "It's a perpetual immobility machine.", 0
.db "",34,"On this spot in 1962, Henry Winkler was sick.",34,"", 0
.db "There's nothing here; it's just an optical illusion.", 0
.db "The World's Biggest Motzah Ball!", 0
.db "A tribe of cannibals lives here. They eat Malt-O-Meal for breakfast, you know.", 0
.db "This appears to be a rather large stack of trashy romance novels.", 0
.db "Look out! Exclamation points!", 0
.db "A herd of wild coffee mugs slumbers here.", 0
.db "It's a limbo bar! How low can you go?", 0
.db "It's the horizon. Now THAT'S weird.", 0
.db "A vase full of artificial flowers is stuck to the floor here.", 0
.db "A large snake bars your way.", 0
.db "A pair of saloon-style doors swing slowly back and forth here.", 0
.db "It's an ordinary bust of Beethoven... but why is it painted green?", 0
.db "It's TV's lovable wisecracking Crow! ",34,"Bite me!",34,", he says.", 0
.db "Hey, look, it's war. What is it good for? Absolutely nothing. Say it again.", 0
.db "It's the amazing self-referential thing that's not kitten.", 0
.db "A flamboyant feather boa. Now you can dress up like Carol Channing!", 0
.db "",34,"Sure hope we get some rain soon,",34," says Farmer Joe.", 0
.db "",34,"How in heck can I wash my neck if it ain't gonna rain no more?",34," asks Farmer Al.", 0
.db "",34,"Topsoil's all gone, ma,",34," weeps Lil' Greg.", 0
.db "This is a large brown bear. Oddly enough, it's currently peeing in the woods.", 0
.db "A team of arctic explorers is camped here.", 0
.db "This object here appears to be Louis Farrakhan's bow tie.", 0
.db "This is the world-famous Chain of Jockstraps.", 0
.db "A trash compactor, compacting away.", 0
.db "This toaster strudel is riddled with bullet holes!", 0
.db "It's a hologram of a crashed helicopter.", 0
.db "This is a television. On screen you see a robot strangely similar to yourself.", 0
.db "This balogna has a first name, it's R-A-N-C-I-D.", 0
.db "A salmon hatchery? Look again. It's merely a single salmon.", 0
.db "It's a rim shot. Ba-da-boom!", 0
.db "It's creepy and it's kooky, mysterious and spooky. It's also somewhat ooky.", 0
.db "This is an anagram.", 0
.db "This object is like an analogy.", 0
.db "It's a symbol. You see in it a model for all symbols everywhere.", 0
.db "The object pushes back at you.", 0
.db "A traffic signal. It appears to have been recently vandalized.", 0
.db "",34,"There is no kitten!",34," cackles the old crone. You are shocked by her blasphemy.", 0
.db "This is a Lagrange point. Don't come too close now.", 0
.db "The dirty old tramp bemoans the loss of his harmonica.", 0
.db "Look, it's Fanny the Irishman!", 0
.db "What in blazes is this?", 0
.db "It's the instruction manual for a previous version of this game.", 0
.db "A brain cell. Oddly enough, it seems to be functioning.", 0
.db "Tea and/or crumpets.", 0
.db "This jukebox has nothing but Cliff Richards albums in it.", 0
.db "It's a Quaker Oatmeal tube, converted into a drum.", 0
.db "This is a remote control. Being a robot, you keep a wide berth.", 0
.db "It's a roll of industrial-strength copper wire.", 0
.db "Oh boy! Grub! Er, grubs.", 0
.db "A puddle of mud, where the mudskippers play.", 0
.db "Plenty of nothing.", 0
.db "Look at that, it's the Crudmobile.", 0
.db "Just Walter Mattheau and Jack Lemmon.", 0
.db "Two crepes, two crepes in a box.", 0
.db "An autographed copy of ",34,"Primary Colors",34,", by Anonymous.", 0
.db "Another rabbit? That's three today!", 0
.db "It's a segmentation fault. Core dumped, by the way.", 0
.db "A historical marker showing the actual location of /dev/null.", 0
.db "Thar's Mobius Dick, the convoluted whale. Arrr!", 0
.db "It's a charcoal briquette, smoking away.", 0
.db "A pizza, melting in the sun.", 0
.db "It's a ",34,"HOME ALONE 2: Lost in New York",34," novelty cup.", 0
.db "A stack of 7 inch floppies wobbles precariously.", 0
.db "It's nothing but a corrupted floppy. Coaster anyone?", 0
.db "A section of glowing phosphor cells sings a song of radiation to you.", 0
.db "This TRS-80 III is eerily silent.", 0
.db "A toilet bowl occupies this space.", 0
.db "This peg-leg is stuck in a knothole!", 0
.db "It's a solitary vacuum tube.", 0
.db "This corroded robot is clutching a mitten.", 0
.db "",34,"Hi, I'm Anson Williams, TV's 'Potsy'.",34,"", 0
.db "This subwoofer was blown out in 1974.", 0
.db "Three half-pennies and a wooden nickel.", 0
.db "It's the missing chapter to ",34,"A Clockwork Orange",34,".", 0
.db "It's a burrito stand flyer. ",34,"Taqueria El Ranchito",34,".", 0
.db "This smiling family is happy because they eat LARD.", 0
.db "Roger Avery, persona un famoso de los Estados Unidos.", 0
.db "Ne'er but a potted plant.", 0
.db "A parrot, kipping on its back.", 0
.db "A forgotten telephone switchboard.", 0
.db "A forgotten telephone switchboard operator.", 0
.db "It's an automated robot-disdainer. It pretends you're not there.", 0
.db "It's a portable hole. A sign reads: ",34,"Closed for the winter",34,".", 0
.db "Just a moldy loaf of bread.", 0
.db "A little glass tub of Carmex. ($.89) Too bad you have no lips.", 0
.db "A Swiss-Army knife. All of its appendages are out. (toothpick lost)", 0
.db "It's a zen simulation, trapped within an ASCII character.", 0
.db "It's a copy of ",34,"The Rubaiyat of Spike Schudy",34,".", 0
.db "It's ",34,"War and Peace",34," (unabridged, very small print).", 0
.db "A willing, ripe tomato bemoans your inability to digest fruit.", 0
.db "A robot comedian. You feel amused.", 0
.db "It's KITT, the talking car.", 0
.db "Here's Pete Peterson. His batteries seem to have long gone dead.", 0
.db "",34,"Blup, blup, blup",34,", says the mud pot.", 0
.db "More grist for the mill.", 0
.db "Grind 'em up, spit 'em out, they're twigs.", 0
.db "The boom box cranks out an old Ethel Merman tune.", 0
.db "It's ",34,"Finding kitten",34,", published by O'Reilly and Associates.", 0
.db "Pumpkin pie spice.", 0
.db "It's the Bass-Matic '76! Mmm, that's good bass!", 0
.db "",34,"Lend us a fiver 'til Thursday",34,", pleas Andy Capp.", 0
.db "It's a tape of '70s rock. All original hits! All original artists!", 0
.db "You've found the fabled America Online disk graveyard!", 0
.db "Empty jewelboxes litter the landscape.", 0
.db "It's the astounding meta-object.", 0
.db "Ed McMahon stands here, lost in thought. Seeing you, he bellows, ",34,"YES SIR!",34,"", 0
.db "...thingy???", 0
.db "It's 1000 secrets the government doesn't want you to know!", 0
.db "The letters O and R.", 0
.db "A magical... magic thing.", 0
.db "It's a moment of silence.", 0
.db "It's Sirhan-Sirhan, looking guilty.", 0
.db "It's ",34,"Chicken Soup for the Kitten-seeking Soulless Robot.",34,"", 0
.db "It is a set of wind-up chatter teeth.", 0
.db "It is a cloud shaped like an ox.", 0
.db "You see a snowflake here, melting slowly.", 0
.db "It's a big block of ice. Something seems to be frozen inside it.", 0
.db "Vladimir Lenin's casket rests here.", 0
.db "It's a copy of ",34,"Zen and The Art of Robot Maintenance",34,".", 0
.db "This invisible box contains a pantomime horse.", 0
.db "A mason jar lies here open. It's label reads: ",34,"do not open!",34,".", 0
.db "A train of thought chugs through here.", 0
.db "This jar of pickles expired in 1957.", 0
.db "Someone's identity disk lies here.", 0
.db "",34,"Yes!",34," says the bit.", 0
.db "",34,"No!",34," says the bit.", 0
.db "A dodecahedron bars your way.", 0
.db "Mr. Hooper is here, surfing.", 0
.db "It's a big smoking fish.", 0
.db "You have new mail in /var/spool/robot", 0
.db "Just a monitor with the blue element burnt out.", 0
.db "A pile of coaxial plumbing lies here.", 0
.db "It's a rotten old shoe.", 0
.db "It's a hundred-dollar bill.", 0
.db "It's a Dvorak keyboard.", 0
.db "It's a cardboard box full of 8-tracks.", 0
.db "Just a broken hard drive containg the archives of Nerth Pork.", 0
.db "A broken metronome sits here, it's needle off to one side.", 0
.db "A sign reads: ",34,"Go home!",34,"", 0
.db "A sign reads: ",34,"No robots allowed!",34,"", 0
.db "It's the handheld robotfindskitten game, by Tiger.", 0
.db "This particular monstrosity appears to be ENIAC.", 0
.db "This is a tasty-looking banana creme pie.", 0
.db "A wireframe model of a hot dog rotates in space here.", 0
.db "Just the empty husk of a locust.", 0
.db "You disturb a murder of crows.", 0
.db "It's a copy of the robotfindskitten EULA.", 0
.db "It's Death.", 0
.db "It's an autographed copy of ",34,"Secondary Colors,",34," by Bob Ross.", 0
.db "It is a marzipan dreadnought that appears to have melted and stuck.", 0
.db "It's a DVD of ",34,"Crouching Monkey, Hidden Kitten",34,", region encoded for the moon.", 0
.db "It's Kieran Hervold.  Damn dyslexia!", 0
.db "A non-descript box of crackers.", 0
.db "Carbonated Water, High Fructose Corn Syrup, Color, Phosphoric Acid, Flavors, Caffeine.", 0
.db "",34,"Move along! Nothing to see here!",34,"", 0
.db "It's the embalmed corpse of Vladimir Lenin.", 0
.db "A coupon for one free steak-fish at your local family diner.", 0
.db "A set of keys to a 2001 Rolls Royce. Worthless.", 0
.db "A gravestone stands here.  ",34,"Izchak Miller, ascended.",34,"", 0
.db "Someone has written ",34,"ad aerarium",34," on the ground here.", 0
.db "A large blue eye floats in midair.", 0
.db "This appears to be a statue of Perseus.", 0
.db "There is an opulent throne here.", 0
.db "It's a squad of Keystone Kops.", 0
.db "This seems to be junk mail addressed to the finder of the Eye of Larn.", 0
.db "A wondrous and intricate golden amulet.  Too bad you have no neck.", 0
.db "The swampy ground around you seems to stink with disease.", 0
.db "An animate blob of acid.  Being metallic, you keep well away.", 0
.db "It's a copy of Knuth with the chapter on kitten-search algorithms torn out.", 0
.db "A crowd of people, and at the center, a popular misconception.", 0
.db "It's a blind man. When you touch, he exclaims ",34,"It's a kitten prospecting robot!",34,"", 0
.db "It's a lost wallet. It's owner didn't have pets, so you discard it.", 0
.db "This place is called Antarctica. There is no kitten here.", 0
.db "It's a mousetrap, baited with soap.", 0
.db "A book with ",34,"Don't Panic",34," in large friendly letters across the cover.", 0
.db "A compendium of haiku about metals.", 0
.db "A discredited cosmology, relic of a bygone era.", 0
.db "A hollow voice says ",34,"Plugh",34,".", 0
.db "A knight who says ",34,"Either I am an insane knave, or you will find kitten.",34,"", 0
.db "A neural net -- maybe it's trying to recognize kitten.", 0
.db "A screwdriver.", 0
.db "A statue of a girl holding a goose like the one in Gottingen, Germany.", 0
.db "A tetradrachm dated ",34,"42 B.C.",34,"", 0
.db "A voice booms out ",34,"Onward, kitten soldiers...",34,"", 0
.db "An eminently forgettable zahir.", 0
.db "Apparently, it's Edmund Burke.", 0
.db "For a moment, you feel something in your hands, but it disappears!", 0
.db "Here is a book about Robert Kennedy.", 0
.db "Hey, robot, leave those lists alone.", 0
.db "Ho hum.  Another synthetic a posteriori.", 0
.db "It's Asimov's Laws of Robotics.  You feel a strange affinity for them.", 0
.db "It's Bach's Mass in B-minor!", 0
.db "It's a bug.", 0
.db "It's a synthetic a priori truth!  Immanuel would be so pleased!", 0
.db "It's the Tiki Room.", 0
.db "Just some old play by a Czech playwright, and you can't read Czech.", 0
.db "Kitten is the letter 'Q'.  Oh, wait, maybe not.", 0
.db "Quidquid Latine dictum sit, kitten non est.", 0
.db "Sutro Tower is visible at some distance through the fog.", 0
.db "The Digital Millennium Copyright Act of 1998.", 0
.db "The United States Court of Appeals for the Federal Circuit.", 0
.db "The non-kitten item like this but with ",34,"false",34," and ",34,"true",34," switched is true.", 0
.db "The non-kitten item like this but with ",34,"true",34," and ",34,"false",34," switched is false.", 0
.db "This is the chapter called ",34,"A Map of the Cat?",34," from Feynman's autobiography.", 0
.db "This is the forest primeval.", 0
.db "Werner's ",34,"Pocket Field Guide to Things That Are Not Kitten",34,".", 0
.db "You found nettik, but that's backwards.", 0
.db "You have found some zinc, but you must not stop here, for you must find kitten.", 0
.db "",34,"50 Years Among the Non-Kitten Items",34,", by Ann Droyd.", 0
.db "",34,"Robot may not injure kitten, or, through inaction, ...",34,"", 0
.db "",34,"Address Allocation for Private Internets",34," by Yakov Rekhter et al.", 0
.db "",34,"Mail Routing and the Domain System",34," by Craig Partridge.", 0
.db "",34,"The Theory and Practice of Oligarchical Collectivism",34," by Emmanuel Goldstein.", 0
.db "",34,"201 Kitten Verbs, Fully Conjugated",34,".  You look for ",34,"find",34,".", 0
.db "A card shark sits here, practicing his Faro shuffle.  He ignores you.", 0
.db "A copy of DeCSS.  They're a dime a dozen these days.", 0
.db "A demonic voice proclaims ",34,"There is no kitten, only Zuul",34,".  You flee.", 0
.db "A lotus.  You make an interesting pair.", 0
.db "A milk carton, with a black and white picture of kitten on the side.", 0
.db "Any ordinary robot could see from a mile away that this wasn't kitten.", 0
.db "A stegosaurus, escaped from the stegosaurusfindsrobot game.  It finds you.", 0
.db "Baling wire and chewing gum.", 0
.db "Chewing gum and baling wire.", 0
.db "Here is no kitten but only rock, rock and no kitten and the sandy road.", 0
.db "Hey, I bet you thought this was kitten.", 0
.db "It is an ancient mariner, and he stoppeth one of three.", 0
.db "It pleases you to be kind to what appears to be kitten -- but it's not!", 0
.db "It's a blatant plug for Ogg Vorbis, http://www.vorbis.com/", 0
.db "It's a business plan for a new startup, kitten.net.", 0
.db "It's a revised business plan for a new startup, my.kitten.net.", 0
.db "It's a square.", 0
.db "It seems to be a copy of ",34,"A Tail of Two Kitties",34,".", 0
.db "It's the Donation of Constantine!", 0
.db "It's this message, nothing more.", 0
.db "Lysine, an essential amino acid.  Well, maybe not for robots.", 0
.db "No kitten here.", 0
.db "The score for a Czech composer's ",34,"Kitten-Finding Symphony in C",34,".", 0
.db "This looks like Bradley's ",34,"Appearance and Reality",34,", but it's really not.", 0
.db "This non-kitten item no verb.", 0
.db "You feel strangely unfulfilled.", 0
.db "You hit the non-kitten item.  The non-kitten item fails to yowl.", 0
.db "You suddenly yearn for your distant homeland.", 0
.db "You've found the snows of yesteryear!  So that's where they all went to.", 0
.db "Approaching.  One car.  J.  Followed by.  Two car.  M, M.  In five. Minutes.", 0
.db "Free Jon Johansen!", 0
.db "Free Dmitry Sklyarov!", 0
.db "One person shouts ",34,"What do we want?",34," The crowd answers ",34,"Free Dmitry!",34,"", 0
.db "Judith Platt insults librarians.", 0
.db "This map is not the territory.", 0
.db "",34,"Go back to Libraria!",34,", says Pat Schroeder.", 0
.db "This is a porcelain kitten-counter.  0, 0, 0, 0, 0...", 0
.db "An old bootable business card, unfortunately cracked down the middle.", 0
.db "A kitten sink, for washing kitten (if only kitten liked water).", 0
.db "A kitten source (to match the kitten sink).", 0
.db "If it's one thing, it's not another.", 0
.db "If it's not one thing, it's another.", 0
.db "A caboodle.", 0
.db "A grin.", 0
.db "A hedgehog.  It looks like it knows something important.", 0
.db "You've found... Oh wait, that's just a cat.", 0
.db "Robot should not be touching that.", 0
.db "Air Guitar!!!  NA na NA na!!", 0
.db "An aromatherapy candle burns with healing light.", 0
.db "You find a bright shiny penny.", 0
.db "It's a free Jon Johansen!", 0
.db "It's a free Dmitry Sklyarov!", 0
.db "The rothe hits!  The rothe hits!", 0
.db "It's an Internet chain letter about sodium laureth sulfate.", 0
.db "Ed Witten sits here, pondering string theory.", 0
.db "Something is written here in the dust.  You read: ",34,"rJbotf ndQkttten",34,".", 0
.db "We wish you a merry kitten, and a happy New Year!", 0
.db "Run away!  Run away!", 0
.db "You can see right through this copy of Brin\'s ",34,"Transparent Society",34,".", 0
.db "This copy of ",34,"Steal This Book",34," has been stolen from a bookstore.", 0
.db "It's Roya Naini.", 0
.db "This kit is the fourteenth in a series of kits named with Roman letters.", 0
.db "This is the tenth key you've found so far.", 0
.db "You find a fraud scheme in which loans are used as security for other loans.", 0
.db "It's the phrase ",34,"and her",34,", written in ancient Greek.", 0
.db "It's the author of ",34,"Randomness and Mathematical Proof",34,".", 0
.db "It's the crusty exoskeleton of an arthropod!", 0
.db "It's Emporer Shaddam the 4th's planet!", 0
.db "It's the triangle leg adjacent to an angle divided by the leg opposite it.", 0
.db "It's a bottle of nail polish remover.", 0
.db "You found netkit! Way to go, robot!", 0
.db "It's the ASCII Floating Head of Seth David Schoen!", 0
.db "A frosted pink party-cake, half eaten.", 0
.db "A bitchin' homemade tesla coil.", 0
.db "Conan O'Brian, sans jawbone.", 0
.db "It's either a mirror, or another soulless kitten-seeking robot.", 0
.db "Preoccupation with finding kitten prevents you from investigating further.", 0
.db "Fonzie sits here, mumbling incoherently about a shark and a pair of waterskis.", 0
.db "The ghost of your dance instructor, his face a paper-white mask of evil.", 0
.db "A bag of groceries taken off the shelf before the expiration date.", 0
.db "A book: Feng Shui, Zen: the art of randomly arranging items that are not kitten.", 0
.db "This might be the fountain of youth, but you'll never know.", 0
.db "Tigerbot Hesh.", 0
.db "Stimutacs.", 0
.db "A canister of pressurized whipped cream, sans whipped cream.", 0
.db "The non-kitten item bites!", 0
.db "A chain hanging from two posts reminds you of the Gateway Arch.", 0
.db "A mathematician calculates the halting probability of a Turing machine.", 0
.db "A number of short theatrical productions are indexed 1, 2, 3, ... n.", 0
.db "A technical university in Australia.", 0
.db "It is -- I just feel something wonderful is about to happen.", 0
.db "It's a Cat 5 cable.", 0
.db "It's a U.S. president.", 0
.db "It's a piece of cloth used to cover a stage in between performances.", 0
.db "The ionosphere seems charged with meaning.", 0
.db "This tomography is like, hella axial, man!", 0
.db "It's your favorite game -- robotfindscatan!", 0
.db "Just a man selling an albatross.", 0
.db "The intermission from a 1930s silent movie.", 0
.db "It's an inverted billiard ball!", 0
.db "The spectre of Sherlock Holmes wills you onwards.", 0
.db 0
